/* Script for swapping default weapons with classic ones without Classic Mode.
Usage: Add #include "classic_weapons" in the script header
then add CLASSICWEAPONS::Enable() in MapInit in your main map script
-Outerbeast 
Very slightly modified for usage with survival and as generic map script.
-Zorik
*/

#include "point_checkpoint"
#include "ins2/melee/weapon_ins2kabar"
#include "ins2/handg/weapon_ins2python"
#include "ins2/handg/weapon_ins2beretta"
#include "ins2/smg/weapon_ins2mp5k"
#include "ins2/shotg/weapon_ins2m590"
#include "ins2/explo/weapon_ins2law"
#include "ins2/explo/weapon_ins2mk2"

void ActivateSurvival(CBaseEntity@ pActivator, CBaseEntity@ pCaller, USE_TYPE useType, float flValue){
	g_SurvivalMode.Activate();
}

void DisableSurvival(CBaseEntity@ pActivator, CBaseEntity@ pCaller, USE_TYPE useType, float flValue){
	g_SurvivalMode.Disable();
}
void EnableSurvival(CBaseEntity@ pActivator, CBaseEntity@ pCaller, USE_TYPE useType, float flValue){
	g_SurvivalMode.Enable(true);
}

namespace CLASSICWEAPONS2{

array<ItemMapping@> CLASSIC_WEAPONS_LIST = 
{
    ItemMapping( "weapon_m16", INS2_MP5K::GetName() ),
    ItemMapping( "weapon_9mmAR", INS2_MP5K::GetName() ),
    ItemMapping( "weapon_uzi", INS2_MP5K::GetName() ),
    ItemMapping( "weapon_uziakimbo", INS2_MP5K::GetName() ),
    ItemMapping( "weapon_crowbar", INS2_KABAR::GetName() ),
    ItemMapping( "weapon_shotgun", INS2_M590::GetName() ),
    ItemMapping( "weapon_9mmhandgun", INS2_M9BERETTA::GetName() ),
    ItemMapping( "weapon_357", INS2_PYTHON::GetName() ),
    ItemMapping( "weapon_handgrenade", INS2_MK2GRENADE::GetName() ),
    ItemMapping( "weapon_rpg", INS2_LAW::GetName() ),
    ItemMapping( "ammo_556clip", INS2_M9BERETTA::GetAmmoName() ),
    ItemMapping( "ammo_9mmuziclip", INS2_MP5K::GetAmmoName() ),
    ItemMapping( "ammo_9mmAR", INS2_MP5K::GetAmmoName() ),
    ItemMapping( "ammo_9mmclip", INS2_M9BERETTA::GetAmmoName() ),
    ItemMapping( "ammo_9mmbox", INS2_MP5K::GetAmmoName() ),
    ItemMapping( "ammo_357", INS2_PYTHON::GetAmmoName() ),
    ItemMapping( "ammo_buckshot", INS2_M590::GetAmmoName() ),
    ItemMapping( "ammo_rpg", INS2_LAW::GetName() )
};

void Enable()
{
    INS2_M590::SLOT = 2;
    INS2_LAW::SLOT = 3;
    INS2_MK2GRENADE::SLOT = 5;

    INS2_KABAR::DAMAGE = 15;
    INS2_M9BERETTA::DAMAGE = 3;
    INS2_PYTHON::DAMAGE = 40;
    INS2_M590::DAMAGE = 3;
    INS2_M590::PELLETCOUNT = 6;
    INS2_MP5K::DAMAGE = 5;
    INS2_LAW::DAMAGE = 100;
    INS2_MK2GRENADE::DAMAGE = 100;

    INS2_M9BERETTA::DEFAULT_GIVE = 30;
    INS2_PYTHON::DEFAULT_GIVE = 12;
    INS2_M590::DEFAULT_GIVE = 12;
    INS2_MP5K::DEFAULT_GIVE = 60;
    INS2_MK2GRENADE::DEFAULT_GIVE = 5;

    INS2_KABAR::Register();
    INS2_PYTHON::Register();
    INS2_M9BERETTA::Register();
    INS2_MP5K::Register();
    INS2_M590::Register();
    INS2_LAW::Register();
    INS2_MK2GRENADE::Register();

    g_ClassicMode.SetItemMappings( @CLASSIC_WEAPONS_LIST );
    g_ClassicMode.ForceItemRemap( true );
    
    g_Hooks.RegisterHook( Hooks::PickupObject::Materialize, ItemSpawned2 );
}    
// World weapon swapper routine (credit to KernCore)
HookReturnCode ItemSpawned2(CBaseEntity@ pOldItem) 
{
    if( pOldItem is null ) 
        return HOOK_CONTINUE;

    for( uint w = 0; w < CLASSIC_WEAPONS_LIST.length(); ++w )
    {
        if( pOldItem.GetClassname() != CLASSIC_WEAPONS_LIST[w].get_From() )
            continue;

        CBaseEntity@ pNewItem = g_EntityFuncs.Create( CLASSIC_WEAPONS_LIST[w].get_To(), pOldItem.GetOrigin(), pOldItem.pev.angles, false );

        if( pNewItem is null ) 
            continue;

        pNewItem.pev.movetype = pOldItem.pev.movetype;

        if( pOldItem.pev.netname != "" )
            pNewItem.pev.netname = pOldItem.pev.netname;

        g_EntityFuncs.Remove( pOldItem );
        
    }
    
    return HOOK_CONTINUE;
}
}
void MapInit(){
	g_Module.ScriptInfo.SetAuthor("Outerbeast, Kerncore, very slightly modified by Zorik");
	g_Module.ScriptInfo.SetContactInfo("Sneed");
	RegisterPointCheckPointEntity();
	if(!g_ClassicMode.IsEnabled())CLASSICWEAPONS2::Enable();
}